# NaNoGenMo

NaNoGenMo (national novel generation month) is a [fun](fun.md) yearly event, running since 2013, in which people make [computer](computer.md) generated novels during the month November. It was inspired by NaNoWriMo (a similar event but for normal, human creative writing) and launched by Darius Kazemi on [Twitter](twitter.md). It is similar e.g. to the [international obfuscated C code contest](ioccc.md) with one difference being that NaNoGenMo is not a contest, it's just a fun activity people do and see what comes out of it. Because of this rules are also very relaxed, something along the lines of "submit a text of around 50000 words that doesn't violate [copyright](copyright.md) along with the code that generated it" (so there appear borderline submissions like non plain text pdfs and so on). At the beginning the text generating programs weren't usually anything too sophisticated, they were mostly things like 100 lines of [Python](python.md) that throw around random sentences, maybe use some [Markov chain](markov_chain.md), maybe some [regex](regex.md) substitution on an already existing book -- most of the entries seemed to be just that. A simple but effective approach that's been used is to simulate some world with actors in it and just let it be documented what they're doing. By 2019 however an increased abuse of language models and other [bloat](bloat.md) started to be noticed, so a kind of [fork](fork.md) event was spawned, called Nano-NaNoGenMo, in which at most 256 character programs are allowed. The sad thing is that NaNoGenMo uses [GitHub](github.md) issues for posting the texts by which they support [terrorists](microsoft.md). Also a lot of participants are huge noobs who share their works using Dropbox and Google documents and similar [shit](shit.md) so they're literally unreachable for most smart people. They also don't require any license, many of the works are [proprietary](proprietary.md). And there doesn't seem to be any nice repository of the entries either, you have to dig them up in the issues or look them up on bloated woke blog posts that attempt to summarize them. There exist similar events for poetry (NaPoGenMo), opera (NaOpGenMo) and movies (NaMoGenMo). The idea of NaNoGenMo is excellent, the execution an uttermost fail.

Some of the generated books were quite popular (though maybe mostly for the nature of having been generated by computers) -- for example the *World Clock*, a Python generated work that just gives random snapshots of people's lives around the world, was even printed and sold. One entry is just a program going through all directories on the harddrive and commenting on them like "wow, there's a lot of files here" and so on. *The Swallows of Summer* had some success depite being just an endless exchange of talk and interactions between Alice and Bob. Some other entries seem to be [interesting](interesting.md), there are e.g. various modifications of the *Moby Dick* or the *Bible* (conveniently well known long works completely in the [public domain](public_domain.md)) -- it's enough to just replace some keywords to get something quite entertaining. [Wikipedia](wikipedia.md) and Project Gutenberg are commonly used as sources of text. One novel just describes someone writing down the digits of [pi](pi.md). Around 2020 many started to use [neural network](neural_network.md) language models, e.g. *A Young "Person"'s Encyclopedia* is a fictional [encyclopedia](encyclopedia.md) made with GPT-3. There is one book in which a model trained on first sentences of famous books just suggests a huge list of new sentences with which one can potentially start a novel.

## See Also

- [ioccc](ioccc.md)
- [SIGBOVIK](sigbovik.md)
- [procedural generaion](progen.md)
- [esoteric programming languages](esolang.md)